import torch
from torch.utils.data import DataLoader
from torchvision import transforms
from torchvision import datasets  # 放置了许多常用数据集,包括手写数字识别
import torch.nn.functional as F
import numpy as np
from torch.utils.data import DataLoader,Dataset,TensorDataset
# from tqdm import tqdm
import os, sys
from torch.nn import init

import os, sys
import time
import pickle
import warnings

warnings.filterwarnings("ignore")
import numpy as np
import torch
import torch.nn as nn
from torch.nn import init
import torch.optim as optim
import torch.nn.functional as F
import matplotlib
import math
matplotlib.use('Agg')
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D
from matplotlib.ticker import LinearLocator, FormatStrFormatter
from matplotlib import cm
import platform
import shutil


os.environ['CUDA_VISIBLE_DEVICES'] = '0,1,2,3,4,5,6,7'
Leftp = 0.18
Bottomp = 0.18
Widthp = 0.88 - Leftp
Heightp = 0.9 - Bottomp
pos = [Leftp, Bottomp, Widthp, Heightp]


def mkdir(fn):  # Create a directory
    if not os.path.isdir(fn):
        os.mkdir(fn)


def save_fig(pltm, fntmp, fp=0, ax=0, isax=0, iseps=0, isShowPic=0):  # Save the figure
    if isax == 1:
        pltm.rc('xtick', labelsize=18)
        pltm.rc('ytick', labelsize=10)
        ax.set_position(pos, which='both')
    fnm = '%s.png' % (fntmp)
    pltm.savefig(fnm)
    if iseps:
        fnm = '%s.eps' % (fntmp)
        pltm.savefig(fnm, format='eps', dpi=600)
    if fp != 0:
        fp.savefig("%s.pdf" % (fntmp), bbox_inches='tight')
    if isShowPic == 1:
        pltm.show()
    elif isShowPic == -1:
        return
    else:
        pltm.close()


transform = transforms.Compose([
    transforms.ToTensor(),  # 转张量，将值缩放到[0,1]之间
    transforms.Normalize((0.1307,),(0.3081,))  # 归一化，第一个为均值，第二个为方差
])
d=3
lst=[2,4,6,15,60,200,400]
t=0


fig, axes = plt.subplots(len(lst), 1, figsize=(9,6),sharex=True, sharey=True)
for i_sub,m in enumerate(lst):
    sev_num = np.zeros(10)
    num1=0#输出与真实值均为7
    num2=0#输出为7真实值不为7
    num3=0#真实值为7输出不为7
    num4=0#输出与真实值均不为7

    print(m)
    PATH='/home/dir/data/saddle_points/test81new/%s/retrain'%(str(m))
    device = torch.device("cuda:%s" % (d) if torch.cuda.is_available() else "cpu")
    batch_size=60000
    train_dataset = datasets.MNIST(root= "/home/dir/data/saddle_points/MNIST/mnist",
                                  train=True,  # 下载训练集
                                  transform=transform,  # 转张量，将值缩放到[0,1]之间.也可以写成transform = transforms.ToTensor()
                                  download=True
                                  )

    test_dataset = datasets.MNIST(root= "/home/dir/data/saddle_points/MNIST/mnist",
                                  train=False,  # 下载训练集
                                  transform=transform,  # 转张量，将值缩放到[0,1]之间
                               download=True)

    batch_size = 20000
    train_dataset0 = []
    train_target0 = []

    #
    for i in range(60000):
        if len(train_dataset0) < 20000:
            train_dataset0.append(train_dataset[i][0].unsqueeze(0))
            train_target0.append(train_dataset[i][1])
        else:
            break

    train_dataset_new = torch.cat(train_dataset0, 0)
    train_label_new = torch.from_numpy(np.array(train_target0))

    train_dataset2 = TensorDataset(train_dataset_new, train_label_new)
    train_loader = DataLoader(train_dataset2, batch_size=batch_size, shuffle=False, num_workers=8)

    test_loader = DataLoader(dataset=test_dataset,
                             batch_size=batch_size,
                             shuffle=False, num_workers=8)
    train_loader = list(train_loader)
    test_loader = list(test_loader)


    class Net(torch.nn.Module):
        def __init__(self,m,t):
            super(Net, self).__init__()
            self.l1 = torch.nn.Linear(784, m)
            init.normal_(self.l1.weight, 0, 1/m**(t))
            init.normal_(self.l1.bias, 0, 1/m**(t))
            self.l2 = torch.nn.Linear(m, m)
            init.normal_(self.l2.weight, 0, 1/m**(t))
            init.normal_(self.l2.bias, 0, 1/m**(t))
            self.l3 = torch.nn.Linear(m, m)
            init.normal_(self.l3.weight, 0, 1/m**(t))
            init.normal_(self.l3.bias, 0, 1/m**(t))
            self.l4 = torch.nn.Linear(m, 10,bias=False)
            init.normal_(self.l4.weight, 0, 1/m**(t))
        def forward(self, x):
            x = x.view(-1, 784)
            x = F.relu(self.l1(x))
            x = F.relu(self.l2(x))
            x = F.relu(self.l3(x))
            # x = F.relu(self.l3(x))
            # x = F.relu(self.l4(x))
            return self.l4(x)


    load_dir='%s/model.ckpt'%(PATH)
    # m=200
    # t=0
    model = Net(m,t).to(device)
    Path1=torch.load(load_dir,map_location='cuda:3')
    model.load_state_dict(Path1)
    # print(model.l1.weight)

    # output_all=[]
    # predict_all=[]
    # correct=int(0)
    for data in train_loader:
        images, labels = data
        np.savetxt('%s/label.txt'%(PATH),labels)
        images = images.to(device)

        labels = labels.to(device)
        # print(labels.shape)
        outputs = model(images)

        # print(outputs.cpu().detach().numpy())
        _, predicted = torch.max(outputs.data, dim=1)  # 返回两个值，第一个是最大值，第二个是最大值的索引。dim=1表示在列维度求以上结果，dim = 0表示在行维度求以上结果。
        outputs = outputs.cpu().detach().numpy()
        predicted=predicted.cpu().detach().numpy()
        # total += labels.size(0)  # 每一个batch_size 中labels是一个（N，1）的元组，size(0)=N
        # correct += (predicted == labels).sum().item()  # 对的总个数
        # break
    # print(correct)
    np.savetxt('%s/output.txt'%(PATH),outputs)
    np.savetxt('%s/predict.txt'%(PATH),predicted)
    for i in range(20000):
        if predicted[i]==7:
            if labels[i]==7:
                num1+=1
            else:
                num2+=1
        if predicted[i] != 7:
            if labels[i]==7:
                num3+=1
            else:
                num4+=1
    for i in range(20000):
        if predicted[i]==7:
            sev_num[int(labels[i])]+=1
    print(sev_num)
    num_lst=[num1,num2,num3,num4]
    np.savetxt('%s/num.txt' % (PATH), num_lst)
    np.savetxt('%s/sev_num.txt' % (PATH), sev_num)



# norm = plt.Normalize(-4,0)

    for ind,i in enumerate(predicted[:100]):
        if i!=7:

            predicted[ind]=0
    print(predicted[:100])

    axes[i_sub].plot(predicted[:100])

    frame = plt.gca()
    frame.axes.get_yaxis().set_visible(False)
    axes[i_sub].set_title('m=%s' % (m), x=-0.08, y=-0.042)
    # axes[i_sub].set_xlim(-5, 1)
    # plt.xlim(-5, 0)
    plt.yticks([])

# set(gca,'XTickLabel',' a')
#
# l = 0.91
# b = 0.12
# w = 0.02
# h = 1 - 2*b
# #对应 l,b,w,h；设置colorbar位置；
# rect = [l,b,w,h]
# cbar_ax = fig.add_axes(rect)
# sm = cm.ScalarMappable(cmap=map_vir, norm=norm)
# sm.set_array([])
# cb = fig.colorbar(sm, cax = cbar_ax)



# plt.colorbar(sm)
plt.xlabel('prediction',fontsize=15, x=-20, y=-200)
plt.subplots_adjust(wspace=0.2, hspace=0.1)
plt.suptitle('The distribution of prediction for diff width')
fntmp = '/home/dir/data/saddle_points/test81new/predicted'
save_fig(plt, fntmp, iseps=0)